import { Entity, ManyToOne, PrimaryKey, Property } from '@mikro-orm/core'
import { BaseEntity } from '#application/base/baseEntity'
import { User } from './user'

@Entity()
export class PasswordResetToken extends BaseEntity {
  @PrimaryKey()
  id!: number

  @ManyToOne(() => User)
  user!: User

  @Property({ unique: true })
  token!: string

  @Property()
  createdAt = new Date()

  setId(id: number) {
    this.id = id
    return this
  }

  getId() {
    return this.id
  }

  setUser(user: User) {
    this.user = user
    return this
  }

  getUser() {
    return this.user
  }

  setToken(token: string) {
    this.token = token
    return this
  }

  getToken() {
    return this.token
  }

  setCreatedAt(createdAt: Date) {
    this.createdAt = createdAt
    return this
  }

  getCreatedAt() {
    return this.createdAt
  }
}
